' ******************************************************************
' This program generates a binary file of random numbers,
' to be used with Marsaglia's DIEHARD battery of tests
' (http://stat.fsu.edu/pub/diehard/)
' ******************************************************************

#INCLUDE "math.bi"

CONST N = 3000000  ' Generate N numbers

DIM AS UINTEGER I, R

CLS

' Select a generator

' SetRNG RNG_MWC
SetRNG RNG_MT
' SetRNG RNG_UVAG

' Initialize the selected generator with the built-in generator

RANDOMIZE TIMER

InitGen RND * 4294967296#

' Create file

OPEN "random.dat" FOR BINARY AS #1

FOR I = 1 TO N
  R = IRanGen
  PUT #1, , R
NEXT I

CLOSE #1

