' ******************************************************************
' Test of Marsaglia's 'Multiply with carry' random number generator
' ******************************************************************
' This program picks 2000 random numbers and displays the next 6
' together with the correct values obtained with the default
' initialization.
' ******************************************************************

#INCLUDE "math.bi"

DIM AS UINTEGER Correct(1 TO 6) = _
{2315938931, _
 2221963912, _
  795854508, _
 2024400257, _
 1291639274, _
 3483712032}

DIM AS UINTEGER I, R

PRINT
PRINT "Test of MWC random number generator"
PRINT "-------------------------------------"
PRINT "       Correct        Actual"
PRINT "-------------------------------------"

SetRNG RNG_MWC

' Pick 2000 random numbers
FOR I = 1 TO 2000: R = IRanGen: NEXT

' Display 6 more numbers with correct values
FOR I = 1 TO 6
  R = IRanGen
  PRINT USING "##############"; Correct(I); R;
  IF Correct(I) = R THEN PRINT "    OK" ELSE PRINT "    BAD"
NEXT I
PRINT "-------------------------------------"

SLEEP
